<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">

  <xsl:template match="/">
      <html>
      <head></head>
      <body>
        <xsl:apply-templates/>
      </body>
      </html>
  </xsl:template>

  <xsl:template match="table">
      <table border="1">
        <xsl:apply-templates/>
      </table>
  </xsl:template>
  
  <xsl:template match="table[not(row)]">
      No row in the result table
  </xsl:template>
  
  <xsl:template match="row">
    <tr>
      <xsl:apply-templates/>
    </tr>
  </xsl:template>

  <xsl:template match="row/col">
	<td><xsl:value-of select="."/></td>
  </xsl:template>

  <xsl:template match="row/col[@name='id' or @name='Id' or @name='Gencod']">
	<td><i><xsl:value-of select="."/></i></td>
  </xsl:template>


  <xsl:template match="row[0]/col">
	<th><xsl:value-of select="@name"/></th>
  </xsl:template>

 
  
</xsl:stylesheet>
