<HTML>
<%@ page import="java.util.*" %>
<HEAD><TITLE>Snooper</TITLE></HEAD>
<BODY>
<H1 align="center">Request Snooper</H1>

<HR>

<h2>Query String:</h2>
<%
out.println(request.getQueryString());
%>

<hr>
<h2>Request Parameters:</h2>
<table border="1">
<tr><th>Name<th>Value
<%
Enumeration pnames = request.getParameterNames();

while (pnames.hasMoreElements()) {
  String name = (String) pnames.nextElement();
  String values[] = request.getParameterValues(name);
  if (values != null) {
    for (int i = 0; i < values.length; i++) {
%>
<tr><td><%=name %>(<%=i %>)<td><%=values[i] %>
<%
    }
  }
}
%>
</table>

<hr>
<h2>Header Parameters:</h2>
<table border="1">
<tr><th>Name<th>Value
<%
Enumeration enum = request.getHeaderNames();
while (enum.hasMoreElements()) {
	String name = (String) enum.nextElement();
	String value = request.getHeader(name);
%>
<tr><td><%=name %><td><%=value %>
<%
}
%>
</table>

<hr>
<h2>Sent Cookies :</h2>
<%
javax.servlet.http.Cookie[] cookies = request.getCookies();
for (int c=0;c<cookies.length;c++) {
%>

<table border="1">
<caption>Cookie[<%=c %>]</caption>
<tr><th>Name:	<td>	<%=cookies[c].getName() %>
<tr><th>Value	<td>	<%=cookies[c].getValue() %>
<tr><th>Domain:	<td>	<%=cookies[c].getDomain() %>
<tr><th>Path:	<td>	<%=cookies[c].getPath()	%>
<tr><th>Secure:	<td>	<%=cookies[c].getSecure() %>
<tr><th>Version:<td>	<%=cookies[c].getVersion() %>
<tr><th>MaxAge:	<td>	<%=cookies[c].getMaxAge() %>
<tr><th>Comment:<td>	<%=cookies[c].getComment() %>
</table>
<%
}
%>


<hr>
<h2>Client snoop:</h2>
request.getRemoteHost(): <%=request.getRemoteHost() %><br>
request.getRemoteAddr(): <%=request.getRemoteAddr() %><br>

<hr>
<h2>Server snoop:</h2>
<%
/*
out.println("getServletContext().getServerInfo(): " +
		servlet.getServletContext().getServerInfo());
Enumeration atts=servlet.getServletContext().getAttributeNames();
while(atts.hasMoreElements()){ // informations supplmentaires du constructeur
	String att= (String)atts.nextElement();
	out.println("getServletContext().getAttribute(\""+att+"\"): " +
		servlet.getServletContext().getAttribute(att);
}
*/
%>
request.getServerName(): <%=request.getServerName() %><br>
request.getServerPort(): <%= request.getServerPort() %><br>
<HR>
</BODY></HTML>