<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">  

<xsl:template match="/">
     <xsl:apply-templates/>
</xsl:template>

<xsl:template match="*">
     <xsl:apply-templates/>
</xsl:template>


<xsl:template match="/">
<html>
    <head>
        <title>Sales Results By Division</title>
    </head>
    <body>
        <table border="1">
            <tr>
                <th>Division</th>
                <th>Revenue</th>
                <th>Growth</th>
                <th>Bonus</th>
            </tr>
            <xsl:apply-templates/>
            <!--<xsl:apply-templates>
              <xsl:sort 	select="revenue"
              			data-type="number"
                          	order="ascending"/>
            </xsl:apply-templates>-->
         </table>
    </body>
</html>
</xsl:template>

<xsl:template  match="sales/division">
                <!-- order the result by revenue 
                <xsl:sort select="revenue"
                          data-type="number"
                          order="ascending"/>-->
                <tr>
                    <td>
                        <em><xsl:value-of select="@id"/></em>
                    </td>
                    <td>
                        <xsl:value-of select="revenue"/>
                    </td>
                    <td>
                        <xsl:value-of select="growth"/>
                    </td>
                    <td>
                        <xsl:value-of select="bonus"/>
                    </td>
                </tr>
</xsl:template>

</xsl:stylesheet>